{% extends "base.html"%}
{% load staticfiles %}

{% block css-content%}
<link href="{% static 'quiz/quiz_detail.css' %}" rel="stylesheet">
{% endblock %}

{% block content%}
<!-- {#% load quiz_tags %#} -->
<nav aria-label="breadcrumb" class="position-fixed">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item"><a href="{% url 'quiz:topic_list' %}">Topic</a></li>
        <li class="breadcrumb-item active" aria-current="page">{{ object.0.topic__name }}</li>
    </ol>
</nav>

<div class="container mt-3">
    <article class="media content-section">
        <div class="media-body mt-5">
            <h2 class="article-title">{{ object.0.topic__name }}</h2>
            <p class="article-content">
                <strong>Objective:</strong>&nbsp;
                Test your knowledge in {{ object.0.topic__name }}
            </p>
            <small class="text-danger">Please don't refresh, otherwise you'll loose your changes</small>
        </div>
        <div class="float-right mt-5">
            <button class="btn btn-danger mb-2 btnEndQuiz">End Quiz</button>
            <br />
            <strong>Your best score:</strong>
            <span id="spn_best_score">{{best_score}}</span>
            <br />
            <strong>Highest Topic Score:</strong>
            <span id="spn_highest_score">
                {{highest_score}}
                {% if highest_scorer|length > 0%}
                    (<strong>{{highest_scorer}}</strong>)
                {% endif %}
            </span>
            <br />
            <strong>Total Questions:</strong>
            <span>{{question_option_dict|length}}</span>
            <br />
            <strong>Attempted:</strong>
            <span id="spnAttempted"></span>
        </div>
    </article>
</div>
<div class="container mt-3">
    <input type="hidden" name="topic" id="topic" value="{{ object.0.topic__slug }}">
    {% for q in object %}
    <div class="divQuestionRow cnt_{{forloop.counter}} q_{{q.id}}">
        <div class="float-left">
            <h3>Q{{forloop.counter}}.</h3>
        </div>
        <div class="float-right ml-3">
            <h3>{{q.question_text}}</h3>
        </div>
    </div>
    <div class="answerRow mt-3 cnt_{{forloop.counter}} q_{{q.id}}">

        {% for key, values in question_option_dict.items %}
        {% if key == q.id %}
        {% for v in values %}
        {% if forloop.first %}
        <div class="newOptionRow">
            {% endif %}
            <div value="{{key}}" class="col-md-5 p-3 border border-dark rounded divRow divOptionValue a_{{v.id}}">
                <h5 class="optionValue mx-auto">{{v.question_option|safe}}</h5>
            </div>
            {% if forloop.counter == 2 %}
        </div>
        <div class="newOptionRow">
            {% endif %}
            {% endfor %}
        </div>
        {% endif %}
        {% endfor %}
    </div>
    {% endfor %}
    <input type="hidden" name="current_question" id="current_question" value="1">
    <input type="hidden" name="total_question" id="total_question" value="{{question_option_dict|length}}">
    <div class="row mt-3">
        <div class="divNavLink">
            <button type="button" class="btn btn-secondary btn_prev">Prev</button>
        </div>
        <div class="divNavLink">
            <button type="button" class="btn btn-dark btn_next">Next</button>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        $("#spnAttempted").html(0);
        cur_quest_number = $("#current_question").val();
        $(".divQuestionRow").not(".cnt_" + cur_quest_number).hide();
        $(".answerRow").not(".cnt_" + cur_quest_number).hide();

        if (cur_quest_number == 1) {
            $(".btn_prev").hide();
        }

        // Disable Right click on page
        $(this).bind("contextmenu", function(e) {
                e.preventDefault();
        });
    });

    $(document).keydown(function(evtobj) {    
        // Disable Control or Shift or Alt key press
        if (evtobj.altKey || evtobj.ctrlKey || evtobj.shiftKey){
            evtobj.preventDefault();
        }
    });

    // function createCookie(name, value, days) {
    //     var expires;
    //     if (days) {
    //         var date = new Date();
    //         date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
    //         expires = "; expires=" + date.toGMTString();
    //     }
    //     else {
    //         expires = "";
    //     }
    //     document.cookie = name + "=" + value + expires + "; path=/";
    // }


    function getCookie(c_name) {
        if (document.cookie.length > 0) {
            c_start = document.cookie.indexOf(c_name + "=");
            if (c_start != -1) {
                c_start = c_start + c_name.length + 1;
                c_end = document.cookie.indexOf(";", c_start);
                if (c_end == -1) c_end = document.cookie.length;
                return unescape(document.cookie.substring(c_start, c_end));
            }
        }
        return "";
    }

    gCookieDictObj = {};

    $(document).on("click", ".btnEndQuiz", function () {
        if (confirm("Sure you want to end your quiz?")){
            optionsMarked = {}
            total_questions = $("#total_question").val();
            var q_regExp = /q_[0-9]+/;
            var a_regExp = /a_[0-9]+/;
            for (var i = 1; i <= total_questions; i++) {
                var elem = $(".cnt_" + i)[1];
                if ($(elem).find(".bg_success").length == 1) {
                    // console.log("exists for index = "+i);
                    quest = parseInt($($(elem).find(".bg_success")[0]).attr("value"));
                    aClasses = $($(elem).find(".bg_success")[0]).attr("class");
                    a_matches = a_regExp.exec(aClasses);
                    answer = parseInt((a_matches[0]).replace('a_', ''));
                    // console.log(quest+" > "+answer);
                    optionsMarked[quest] = answer;
                } else {
                    qClasses = $($(".cnt_" + i)[1]).attr("class");
                    q_matches = q_regExp.exec(qClasses);
                    quest = parseInt((q_matches[0]).replace('q_', ''));
                    optionsMarked[quest] = 0;
                }
            }


            $.ajax({
                url: '/quiz/updateScore/',
                dataType: 'json',
                type: 'post',
                headers: { "X-CSRFToken": getCookie("csrftoken") },
                // contentType: 'application/x-www-form-urlencoded',
                data: { 'values': JSON.stringify(optionsMarked), "topic": $("#topic").val() },
                success: function (data, textStatus, jQxhr) {
                    // $('#response pre').html(data);
                    // console.log("AJAX Success");
                    console.log(data)
                    $("#spn_best_score").html((data)["best_score"])
                    $("#spn_highest_score").html((data)["highest_score"])
                    // console.log(textStatus);
                    // console.log(jQxhr);
                },
                error: function (jqXhr, textStatus, errorThrown) {
                    // console.log("AJAX Error");
                    console.log(jqXhr);
                    console.log(errorThrown);
                    console.log(textStatus);
                }
            });
        }
    });

    $(document).on("click", ".divOptionValue", function () {
        var qClasses = $(".divQuestionRow:visible").attr("class");

        var q_regExp = / q_([0-9]+)$/;
        if (qClasses.match(q_regExp)) {
            var q_matches = q_regExp.exec(qClasses);

            cookieTitle = $(".breadcrumb-item.active").text();

            var aClasses = $(this).attr("class");
            var a_regExp = / a_([0-9]+)$/;

            if (aClasses.match(a_regExp)) {
                var a_matches = a_regExp.exec(aClasses);
                if (cookieTitle != undefined && cookieTitle != null && cookieTitle != "" && cookieTitle != "undefined") {
                    cookieTitle = cookieTitle.toLowerCase();
                    q_sel = q_matches[1];
                    a_sel = a_matches[1];

                    if (JSON.stringify(gCookieDictObj) == JSON.stringify({})) {
                        gCookieDictObj[cookieTitle] = {};
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle] == undefined || gCookieDictObj[cookieTitle] == "") {
                        gCookieDictObj[cookieTitle] = {};
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle][q_sel] == undefined) {
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle][q_sel] != undefined) {
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    }

                    $(".divOptionValue:visible").removeClass("bg_success");
                    $(this).addClass("bg_success");
                    // console.log(gCookieDictObj);

                    attempted_questions = parseInt($(".bg_success").length);
                    $("#spnAttempted").html(attempted_questions);

                }
            }
        }

    });

    $(document).on("click", ".btn_prev", function () {
        document.body.scrollTop = 0; // For Safari
        document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera

        display_question_number = $("#current_question").val();
        display_question_number--;

        // $(".divQuestionRow").not(".cnt_"+display_question_number).hide();
        // $(".answerRow").not(".cnt_"+display_question_number).hide();
        $(".divQuestionRow").hide();
        $(".answerRow").hide();
        $(".cnt_" + display_question_number).show();

        if (display_question_number > 1) {
            $(".btn_prev").show();
        } else {
            $(".btn_prev").hide();
        }

        if (display_question_number < total_question) {
            $(".btn_next").show();
        }else{
            $(".btn_next").hide();
        }

        $("#current_question").val(display_question_number);
    });

    $(document).on("click", ".btn_next", function () {
        document.body.scrollTop = 0; // For Safari
        document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera

        display_question_number = $("#current_question").val();
        display_question_number++;


        // $(".divQuestionRow").not(".cnt_"+display_question_number).hide();
        // $(".answerRow").not(".cnt_"+display_question_number).hide();
        $(".divQuestionRow").hide();
        $(".answerRow").hide();
        $(".cnt_" + display_question_number).show();
        $("#current_question").val(display_question_number);
        total_question = $("#total_question").val();
        $(".btn_prev").show();

        if (display_question_number < total_question) {
            $(".btn_next").show();
        }else{
            $(".btn_next").hide();
        }
    });
</script>
{% endblock%}